#/bin/bash
#
#Geschwindigkeit des DVD-LW einstellen
#
#

speed="$1"
DVD_LW="/dev/dvd"
log_file="/var/log/dvd_bremsen.log"
locale="/etc/rc.local"
DAEMON="/usr/bin/speedcontrol"

#Geschwindigkeit abfragen
if [ $speed = "frage" ]
	then
		grep -n speedcontrol $locale | cut  -d " " -f 3 >/dev/null 2>&1
		if [ "$?" != "0" ]
			then
				svdrpsend.sh MESG "DVD-LW auf $Abfrage x Umdrehungen begrenzt"
			else
				svdrpsend.sh MESG "DVD-LW Umdrehungsbegrenzt aufgehoben"
		fi	
		exit 0
fi

#Eintrag entfernen
if [ $speed = "aus" ]
	then
		grep "^speedcontrol -x" ${locale} >/dev/null 2>&1
		if [ "$?" = "0" ]
			then
				> ${locale}.tmp
				sed -e "/speedcontrol/d" "$locale" >> $locale.tmp
				cat $locale.tmp > $locale
				rm $locale.tmp
				$DAEMON -x 0 "$DVD_LW"
				svdrpsend.sh MESG "DVD-LW Begrenzung gelöscht!"
			
		fi	
	exit 0
fi


#ist der Parameter $speed zwischen 0-9
if echo $speed | egrep "^[0-9]{1}$" > /dev/null 2>&1
	then
		#ist /dev/dvd ein blockdevice
		if [ -b "$DVD_LW" ]
			then
				# ist speedcontrol vorhanden
				if [ -x $DAEMON ]
					then
					# Geschwindigkeit setzten
					$DAEMON -x "$speed" "$DVD_LW"
					# Eintrag in /etc/rc.local aktualisieren
					grep "^speedcontrol -x" ${locale} >/dev/null 2>&1
						if [ "$?" = "0" ]
							then
        							> ${locale}.tmp
								sed -e "/speedcontrol/d" "$locale" >> $locale.tmp
								cat $locale.tmp > $locale
								echo "speedcontrol -x $speed $DVD_LW" >> $locale
								> ${locale}.tmp
								sed -e "/exit 0/d" "$locale" >> $locale.tmp
								cat $locale.tmp > $locale
								echo "exit 0" >> $locale
								rm $locale.tmp
							else
								echo "speedcontrol -x $speed $DVD_LW" >> $locale
								sed -e "/exit 0/d" "$locale" >> $locale.tmp
								cat $locale.tmp > $locale
								echo "exit 0" >> $locale
								rm $locale.tmp
						fi 	
					else
					svdrpsend.sh MESG "##Fehler! $exec nicht ausführbar##"
					echo "$(date +'%y.%m.%d %H:%M:%S') speedcontrol nicht ausführbar! config prüfen" >> $log_file
					exit 1
				fi
			else
			svdrpsend.sh MESG "##Fehler! $DVD_LW ist kein Laufwerk##"
			echo "$(date +'%y.%m.%d %H:%M:%S') $DVD_LW ist kein Blockdevice! config prüfen" >> $log_file
			exit 1
		fi
	else
	svdrpsend.sh MESG "##Fehler! falsche Geschwindikeit##"
	echo "$(date +'%y.%m.%d %H:%M:%S') ##$speed## ist nicht zwischen 0-9!" >> $log_file
	exit 1
fi


if [ $speed = "0" ]
	then
		svdrpsend.sh MESG "DVD-LW Umdrehungsbegrenzt aufgehoben"
		echo "$(date +'%y.%m.%d %H:%M:%S') DVD-LW Umdrehungsbegrenzt aufgehoben" >> $log_file
	else
		svdrpsend.sh MESG "DVD-LW auf $speed x Umdrehungen begrenzt"
		echo "$(date +'%y.%m.%d %H:%M:%S') DVD-LW auf $speed x Umdrehungen begrenzt" >> $log_file
fi
exit 0